import objectdraw.*;
import java.awt.*;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

/* 
 * Replace this with your comment about class Frogger, and please don't 
 * forget to include your name!
 * 
 */

public class Frogger extends WindowController implements KeyListener {

    // The size of the window for Frogger
    private static final int SCREEN_WIDTH = 800;
    private static final int SCREEN_HEIGHT = 644;

    // The sizes of the background components.
    private static final double HIGHWAY_LENGTH = 700;
    private static final double LANE_WIDTH = 100;
    private static final int NUM_LANES = 4;
    private static final double HIGHWAY_WIDTH = LANE_WIDTH * NUM_LANES;
    private static final double LINE_WIDTH = LANE_WIDTH / 10;

    // The locations of the background components
    private static final double HIGHWAY_LEFT = 50;
    private static final double HIGHWAY_RIGHT = HIGHWAY_LEFT + HIGHWAY_LENGTH;
    private static final double HIGHWAY_TOP = 100;
    private static final double HIGHWAY_BOTTOM = HIGHWAY_TOP + HIGHWAY_WIDTH;

    // The lines on the highway
    private static final double LINE_SPACING = LINE_WIDTH / 2;
    private static final double DASH_LENGTH = LANE_WIDTH / 3;
    private static final double DASH_SPACING = DASH_LENGTH / 2;

    // Size of the frog image
    private static final double FROG_WIDTH = 83;
    private static final double FROG_HEIGHT = 48;

    /*
     * This method current just draws the highway.  You will have to
     * add instructions to create the frog and the Lane ActiveObjects.
     */
    public void begin() {
        // make sure the canvas has the assumed dimensions
        setSize(SCREEN_WIDTH, SCREEN_HEIGHT);

        // set up to accept key events
        requestFocus();
        addKeyListener(this);
        canvas.addKeyListener(this);

        // draw the highway using the methods below.
        this.createHighway();

        // ADD YOUR CODE TO CREATE THE FROG AND THE LANES
    }

    /*
     * Draw the highway background.
     * 
     * YOU SHOULD NOT NEED TO MODIFY THIS METHOD
     */
    public void createHighway() {

        // Draw the pavement
        new FilledRect(HIGHWAY_LEFT, HIGHWAY_TOP, HIGHWAY_LENGTH,
            HIGHWAY_WIDTH, canvas);

        // Draw the lane dividers
        for (int whichLine = 1; whichLine < NUM_LANES; whichLine++) {
            if (whichLine == (NUM_LANES / 2)) {
                // The middle line is a no passing line
                this.drawNoPassingLine((HIGHWAY_TOP + (whichLine * LANE_WIDTH)) -
                    ((LINE_SPACING / 2) + LINE_WIDTH));
            } else {
                this.drawPassingLine((HIGHWAY_TOP + (whichLine * LANE_WIDTH)) -
                    (LINE_WIDTH / 2));
            }
        }
    }

    /*
     * Draws a pair of solid yellow lines to represent a no passing
     * divider between lanes.  The parameter y is the top of the top
     * line.
     *
     * YOU SHOULD NOT NEED TO MODIFY THIS METHOD
     */
    public void drawNoPassingLine(double y) {
        FilledRect topLine = new FilledRect(HIGHWAY_LEFT, y, HIGHWAY_LENGTH,
                LINE_WIDTH, canvas);
        topLine.setColor(Color.yellow);

        FilledRect bottomLine = new FilledRect(HIGHWAY_LEFT,
                y + LINE_WIDTH + LINE_SPACING, 
                HIGHWAY_LENGTH, LINE_WIDTH,
                canvas);
        bottomLine.setColor(Color.yellow);
    }

    /*
     * Draws a dashed white line to represent a passing line dividing
     * two lanes of traffic The parameter is the top of the line.
     *
     * YOU SHOULD NOT NEED TO MODIFY THIS METHOD
     */
    public void drawPassingLine(double y) {
        double x = HIGHWAY_LEFT;

        while (x < HIGHWAY_RIGHT) {
            // Draw the next dash.
            FilledRect dash = new FilledRect(x, y, 
                    DASH_LENGTH, LINE_WIDTH,
                    canvas);
            dash.setColor(Color.white);
            x = x + DASH_LENGTH + DASH_SPACING;
        }
    }

    // not needed except to satisfy the KeyListener interface
    public void keyTyped(KeyEvent e) {}

    public void keyReleased(KeyEvent e) {}

    public void keyPressed(KeyEvent e) {
        // ADD YOUR CODE HERE TO HANDLE KEY EVENTS
    }

}
